Reference Manual

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# Inti::Gtk::Entry Class Reference

A GtkEntry C++ wrapper class. More...

`#include <inti/gtk/entry.h>`

Inheritance diagram for Inti::Gtk::Entry:

List of all members.

## Public Member Functions

Constructors

- Entry ()
    Construct a new Entry.
- Entry (int max_length)
    Construct a new Entry that accepts at most max_length characters.
- virtual ~Entry ()
    Destructor.

Accessors

- GtkEntry * gtk_entry () const
    Get a pointer to the GtkEntry structure.
- GtkEntryClass * gtk_entry_class () const
    Get a pointer to the GtkEntryClass structure.
- operator GtkEntry * () const
    Conversion operator; safely converts an Entry to a GtkEntry pointer.
- String get_text () const
    Retrieves the contents of the widget (see also Gtk::Editable::get_chars()).
- bool get_visibility () const
    Returns true if the text in the widget is visible (see set_visibility()).
- G::Unichar get_invisible_char () const
    Retrieves the character displayed in place of the real characters for entries with visisbility set to false (see set_invisible_char()).
- bool get_has_frame () const
    Returns true if the entry has a beveled frame (see set_has_frame()).
- bool get_activates_default () const
    Returns true if the entry will activate the default widget (see set_activates_default()).
- int get_width_chars () const
    Retrieves the number of chars to request space for, or negative if unset (see set_width_chars()).
- int get_max_length () const
    Returns the maximum allowed length of the text in the Entry, or 0 if there is no maximum (see set_max_length()).
- Pango::Layout * get_layout () const
    Gets the Pango::Layout used to display the entry.
- void get_layout_offsets (int *x, int *y) const
    Obtains the position of the Pango::Layout used to render text in the entry, in widget coordinates.

Methods

- void set_visibility (bool visible)
    Sets whether the contents of the entry are visible or not.
- void set_invisible_char (G::Unichar ch)
    Sets the character to use in place of the actual text when set_visibility() has been called to set text visibility to false.
- void set_has_frame (bool setting)
    Sets whether the entry has a beveled frame around it.
- void set_max_length (int max)
    Sets the maximum allowed length of the contents of the widget.
- void set_text (const String &text)
    Sets the text in the widget to the given value, replacing the current contents.
- void set_activates_default (bool setting)
    If setting is true, pressing Enter in the entry will activate the default widget for the window containing the entry.
- void set_width_chars (int n_chars)
    Changes the size request of the entry to be about the right size for n_chars characters.

Property Proxies

- const CursorPositionPropertyProxy prop_cursor_position ()
    The current position of the insertion cursor in chars (int : Read).
- const SelectionBoundPropertyProxy prop_selection_bound ()
    The position of the opposite end of the selection from the cursor in chars (int : Read).
- const EditablePropertyProxy prop_editable ()
    Whether the entry contents can be edited (bool : Read / Write).
- const MaxLengthPropertyProxy prop_max_length ()
    Maximum number of characters for this entry. Zero if no maximum (int : Read / Write).
- const VisibilityPropertyProxy prop_visibility ()
    Set false to display the "invisible char" instead of the actual text in password mode (bool : Read / Write).
- const HasFramePropertyProxy prop_has_frame ()
    Set false to remove outside bevel from entry (bool : Read / Write).
- const InvisibleCharPropertyProxy prop_invisible_char ()
    The character to use when masking entry contents in "password mode" (unsigned int : Read / Write).
- const ActivatesDefaultPropertyProxy prop_activates_default ()
    Whether to activate the default widget (such as the default button in a dialog) when Enter is pressed (bool : Read / Write).
- const WidthCharsPropertyProxy prop_width_chars ()
    Number of characters to leave space for in the entry (int : Read / Write).
- const ScrollOffsetPropertyProxy prop_scroll_offset ()
    Number of pixels of the entry scrolled off the screen to the left (int : Read).
- const TextPropertyProxy prop_text ()
    The contents of the entry (String : Read / Write).

Signal Proxies

- const PopulatePopupSignalProxy sig_populate_popup ()
    Connect to the populate_popup_signal; emitted when the Entry displays its context-sensitive menu.
- const ActviateSignalProxy sig_activate ()
    Connect to the activate_signal; emitted when the Entry is activated by pressing the enter key.
- const InsertAtCursorSignalProxy sig_insert_at_cursor ()
    Connect to the insert_at_cursor_signal; emitted when text is inserted into the Entry at the current cursor position.

## Protected Member Functions

Constructors

- Entry (GtkEntry *entry, bool reference=false)
    Construct a new Entry from an existing GtkEntry.

Signal Handlers

- virtual void on_populate_popup (Menu &menu)
    Called when the Entry displays its context-sensitive menu.
- virtual void on_activate ()
    Called when the Entry is activated by pressing the enter key.
- virtual void on_insert_at_cursor (const String &text)
    Called when text is inserted into the Entry at the current cursor position.

## Detailed Description

A GtkEntry C++ wrapper class.

The Entry widget is a single line text entry widget. A fairly large set of key bindings are supported by default. If the entered text is longer than the allocation of the widget, the widget will scroll so that the cursor position is visible. Entry implements the Editable and CellEditable interfaces

## Constructor & Destructor Documentation

Inti::Gtk::Entry::Entry | ( | GtkEntry * | entry,
|  | bool | reference = false
| ) | `[explicit, protected]`

Construct a new Entry from an existing GtkEntry.

Parameters:

  entry | A pointer to a GtkEntry.
  reference | Set false if the initial reference count is floating, set true if it's not.

The entry can be a newly created GtkEntry or an existing GtkEntry (see G::Object::Object).

Inti::Gtk::Entry::Entry | ( | int | max_length | ) | `[explicit]`

Construct a new Entry that accepts at most max_length characters.

Parameters:

  max_length | The maximum length of the entry, or 0 for no maximum.

The value passed max_length in will be clamped to the range 0-65536.

## Member Function Documentation

G::Unichar Inti::Gtk::Entry::get_invisible_char | ( |  | ) | const

Retrieves the character displayed in place of the real characters for entries with visisbility set to false (see set_invisible_char()).

Returns:
  The current invisible char, or 0, if the entry does not show invisible text at all.

Pango::Layout* Inti::Gtk::Entry::get_layout | ( |  | ) | const

Gets the Pango::Layout used to display the entry.

Returns:
  The PangoLayout for this entry.

The layout is useful to e.g. convert text positions to pixel positions, in combination with get_layout_offsets(). The returned layout is owned by the entry and must not be unreferenced by the caller.

void Inti::Gtk::Entry::get_layout_offsets | ( | int * | x,
|  | int * | y
| ) | const

Obtains the position of the Pango::Layout used to render text in the entry, in widget coordinates.

Parameters:

  x | The location to store the X offset of the layout, or null.
  y | The location to store the Y offset of the layout, or null.

Useful if you want to line up the text in an entry with some other text, e.g. when using the entry to implement editable cells in a sheet widget. Also useful to convert mouse events into coordinates inside the Pango::Layout, e.g. to take some action if some part of the entry text is clicked.

String Inti::Gtk::Entry::get_text | ( |  | ) | const

Retrieves the contents of the widget (see also Gtk::Editable::get_chars()).

Returns:
  A String that contains the contents of the widget.

virtual void Inti::Gtk::Entry::on_insert_at_cursor | ( | const String & | text | ) | `[protected, virtual]`

Called when text is inserted into the Entry at the current cursor position.

Parameters:

  text | The new text to insert.

virtual void Inti::Gtk::Entry::on_populate_popup | ( | Menu & | menu | ) | `[protected, virtual]`

Called when the Entry displays its context-sensitive menu.

Parameters:

  menu | The popup menu.

void Inti::Gtk::Entry::set_activates_default | ( | bool | setting | ) |

If setting is true, pressing Enter in the entry will activate the default widget for the window containing the entry.

Parameters:

  setting | true to activate the default widget on Enter keypress.

If setting is true, this usually means that the dialog box containing the entry will be closed, since the default widget is usually one of the dialog buttons.

void Inti::Gtk::Entry::set_has_frame | ( | bool | setting | ) |

Sets whether the entry has a beveled frame around it.

Parameters:

  setting | The new value.

void Inti::Gtk::Entry::set_invisible_char | ( | G::Unichar | ch | ) |

Sets the character to use in place of the actual text when set_visibility() has been called to set text visibility to false.

Parameters:

  ch | A Unicode character.

The ch character is used in "password mode" to show the user how many characters have been typed. The default invisible char is an asterisk ('*'). If you set the invisible char to 0, then the user will get no feedback at all; there will be no text on the screen as they type.

void Inti::Gtk::Entry::set_max_length | ( | int | max | ) |

Sets the maximum allowed length of the contents of the widget.

Parameters:

  max | The maximum length of the entry, or 0 for no maximum.

The value passed in will be clamped to the range 0-65536. If the current contents are longer than the given length, then they will be truncated to fit.

void Inti::Gtk::Entry::set_text | ( | const String & | text | ) |

Sets the text in the widget to the given value, replacing the current contents.

Parameters:

  text | The new text.

void Inti::Gtk::Entry::set_visibility | ( | bool | visible | ) |

Sets whether the contents of the entry are visible or not.

Parameters:

  visible | true if the contents of the entry are displayed as plain text.

When visibility is set to false, characters are displayed as the invisible char, and will also appear that way when the text in the entry widget is copied elsewhere. The default invisible char is the asterisk '*', but it can be changed with set_invisible_char().

void Inti::Gtk::Entry::set_width_chars | ( | int | n_chars | ) |

Changes the size request of the entry to be about the right size for n_chars characters.

Parameters:

  n_chars | The width in chars.

Note that this method changes the size request, the size can still be affected by how you pack the widget into containers. If n_chars is -1, the size reverts to the default entry size.

The documentation for this class was generated from the following file:

- entry.h

Main Page - Footer